#ifndef __SERVICES_H__
#define __SERVICES_H__

// various services, like minimal value, floor etc

namespace te
{
// find minimal value
    inline int minimal (int a, int b)
    {
        if (a > b) return b; else return a;
    }
//find maximal value
    inline int maximal (int a, int b)
    {
        if (a < b) return b; else return a;
    }
//ensure a value is between two limits
    template <class t>
    void ensure(t a, t b, t& value)
    {
        if (b < a)
        {
            t tmp = a;
            b = a;
            a = tmp;
        }
        if (value < a) value = a;
        if (value > b) value = b;
    }
// find absolute (signless) value
    inline double absolute (double val)
    {
        if (val >= 0)
            return val;
        else
            return -val;
    }


};

#endif
