/*
*  this file provides a wrapper for timing functions
*/

#ifndef __TIMING_H__
#define __TIMING_H__

#include <windows.h>
#include <mmsystem.h>
#include <winbase.h>

#include  <iostream>

namespace te
{
//#########################################################################
    inline unsigned int getTicks()
    {
        return timeGetTime();
    };
//#########################################################################
    inline void pause(unsigned int howLong)
    {
        Sleep(howLong);
    };
//#########################################################################
    class runTime
    {
    public: //-------------------------------------------------------------
        runTime()
        {
            val = getTicks();
        }
    //---------------------------------------------------------------------
        unsigned int now() // call this to get the delay from last reset
                           // and reset the timer value
        {
            unsigned int retVal = getTicks() - val;
            val = getTicks();
            return  retVal;
        }
    //---------------------------------------------------------------------
        unsigned int later() // call this to get the delay from last reset
                             // when you don't want to reset the value
        {
            return  getTicks() - val;
        }
    //---------------------------------------------------------------------
    private:
        unsigned int val;
    };
};


#endif