#ifndef __CLIENT_REACTIONS_H_
#define __CLIENT_REACTIONS_H_

#include "action_map.h"
#include "map.h"
#include <iostream>

namespace te
{
class client;
//#############################################################################
class reaction_set_map_size : public reaction
{
public: //---------------------------------------------------------------------
    reaction_set_map_size (client& its_client) : my_client_(its_client)
    {
    }
//-----------------------------------------------------------------------------
    ~reaction_set_map_size ()
    {
    }
//-----------------------------------------------------------------------------
    void setParams(datagram& dgram);
//-----------------------------------------------------------------------------
    void invoke();
private: //--------------------------------------------------------------------
    client& my_client_;
    size_t longitude_;
    size_t lattitude_;
};
//#############################################################################
class reaction_leaf_send : public reaction
{
public: //---------------------------------------------------------------------
    reaction_leaf_send (client& its_client) : my_client_(its_client)
    {
    }
//-----------------------------------------------------------------------------
    ~reaction_leaf_send ()
    {
    }
//-----------------------------------------------------------------------------
    void setParams(datagram& dgram);
//-----------------------------------------------------------------------------
//    void invoke();
private: //--------------------------------------------------------------------
    client& my_client_;
};
//#############################################################################
class reaction_date_and_time : public reaction
{
public: //---------------------------------------------------------------------
    reaction_date_and_time (client& its_client) : my_client_(its_client)
    {
    }
//-----------------------------------------------------------------------------
    ~reaction_date_and_time ()
    {
    }
//-----------------------------------------------------------------------------
    void setParams(datagram& dgram);
//-----------------------------------------------------------------------------
//    void invoke();
private: //--------------------------------------------------------------------
    client& my_client_;
};
//#############################################################################

};

#endif